#!/bin/bash
# get status of Masscope IDE Raid

IP_IDE_RAID="192.168.0.1"

cd /www/ide-raid/${IP_IDE_RAID}

for i in log html txt dif
do
  mv -f status.$i status.$i.old 2>/dev/null
done
mv -f temperatures.txt temperatures.txt.old 2>/dev/null
#
wget -T 60 -o status.log -O status.html http://${IP_IDE_RAID}/status
RC=$?
touch status.html
if [ ! "${RC}" = "0" ]; then
  echo "wget error with ${IP_IDE_RAID} (RC=${RC})."
  continue
fi
html2text -nobs -width 333 status.html | tr _ \  | tr \| \ | tr -s \  >status.txt
diff -b -U 0 status.txt.old status.txt | \
  grep -v "^---\|^+++\|^@@\|Temperature\|Progress" >status.dif
test -s status.dif && echo "${IP_IDE_RAID} status change:" && cat status.dif
grep "Front\|Temperature" status.txt | (while read a b c d e f g h i; \
  do
    if [ "${a} ${b} ${c} ${d}." = "Disk Stack Temperature (." ]; then
      echo -n "${e} ${f} ${g} ${h}" >temperatures.txt 
      TEMP_D1=${e%%.*}
      if [ ${TEMP_D1} -gt 40 ]; then
        echo "${IP_IDE_RAID} TEMP_D1 is ${e} C."
      fi
      TEMP_D2=${f%%.*}
      if [ ${TEMP_D2} -gt 40 ]; then
        echo "${IP_IDE_RAID} TEMP_D2 is ${f} C."
      fi
      TEMP_D3=${g%%.*}
      if [ ${TEMP_D3} -gt 40 ]; then
        echo "${IP_IDE_RAID} TEMP_D3 is ${g} C."
      fi
      TEMP_D4=${h%%.*}
      if [ ${TEMP_D4} -gt 40 ]; then
        echo "${IP_IDE_RAID} TEMP_D4 is ${h} C."
      fi
    elif [ "${a} ${b} ${c}." = "Ambient Temperature (." ]; then
      echo " ${d}" >>temperatures.txt 
      TEMP_AMB=${d%%.*}
      if [ ${TEMP_AMB} -gt 40 ]; then
        echo "${IP_IDE_RAID} TEMP_AMB is ${d} C."
      fi
    elif [ "${a} ${b}." = "Front Fans." ]; then
      if [ ! "${c} ${d} ${e} ${f}." = "OK OK OK OK." ]; then
        echo "${IP_IDE_RAID} Front Fans bad: ${c} ${d} ${e} ${f}."
      fi
    else
      echo "unparsed line: ${a} ${b} ${c} ${d} ${e} ${f} ${g} ${h} ${i}"
    fi
  done
